Index: src/Actions/MoleculeAction/ChangeNameAction.cpp
===================================================================
--- src/Actions/MoleculeAction/ChangeNameAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/ChangeNameAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,87 @@
+/*
+ * ChangeNameAction.cpp
+ *
+ *  Created on: Jan 15, 2010
+ *      Author: crueger
+ */
+
+#include "Actions/MoleculeAction/ChangeNameAction.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+#include "atom.hpp"
+#include "molecule.hpp"
+
+/****** MoleculeChangeNameAction *****/
+
+// memento to remember the state when undoing
+
+class MoleculeChangeNameState : public ActionState {
+public:
+  MoleculeChangeNameState(molecule* _mol,std::string _lastName) :
+    mol(_mol),
+    lastName(_lastName)
+  {}
+  molecule* mol;
+  std::string lastName;
+};
+
+const char MoleculeChangeNameAction::NAME[] = "Change filename of Molecule";
+
+MoleculeChangeNameAction::MoleculeChangeNameAction() :
+  Action(NAME)
+{}
+
+MoleculeChangeNameAction::~MoleculeChangeNameAction()
+{}
+
+Action::state_ptr MoleculeChangeNameAction::performCall() {
+  string filename;
+  molecule *mol = NULL;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+
+  dialog->queryMolecule(NAME, &mol, MapOfActions::getInstance().getDescription(NAME));
+  dialog->queryString("Enter name: ",&filename);
+
+  if(dialog->display()) {
+    string oldName = mol->getName();
+    mol->setName(filename);
+    delete dialog;
+    return Action::state_ptr(new MoleculeChangeNameState(mol,oldName));
+  }
+  delete dialog;
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeChangeNameAction::performUndo(Action::state_ptr _state) {
+  MoleculeChangeNameState *state = assert_cast<MoleculeChangeNameState*>(_state.get());
+
+  string newName = state->mol->getName();
+  state->mol->setName(state->lastName);
+
+  return Action::state_ptr(new MoleculeChangeNameState(state->mol,newName));
+}
+
+Action::state_ptr MoleculeChangeNameAction::performRedo(Action::state_ptr _state){
+  // Undo and redo have to do the same for this action
+  return performUndo(_state);
+}
+
+bool MoleculeChangeNameAction::canUndo() {
+  return true;
+}
+
+bool MoleculeChangeNameAction::shouldUndo() {
+  return true;
+}
+
+const string MoleculeChangeNameAction::getName() {
+  return NAME;
+}
Index: src/Actions/MoleculeAction/ChangeNameAction.hpp
===================================================================
--- src/Actions/MoleculeAction/ChangeNameAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/ChangeNameAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,35 @@
+/*
+ * ChangeNameAction.hpp
+ *
+ *  Created on: Jan 15, 2010
+ *      Author: crueger
+ */
+
+#ifndef CHANGENAMEACTION_HPP
+#define CHANGENAMEACTION_HPP
+
+#include "Actions/Action.hpp"
+#include "Actions/Process.hpp"
+
+class MoleculeListClass;
+
+class MoleculeChangeNameAction : public Action {
+public:
+  MoleculeChangeNameAction();
+  virtual ~MoleculeChangeNameAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  MoleculeListClass *molecules;
+  static const char NAME[];
+};
+
+
+#endif // CHANGENAMEACTION_HPP
Index: src/Actions/MoleculeAction/FillWithMoleculeAction.cpp
===================================================================
--- src/Actions/MoleculeAction/FillWithMoleculeAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/FillWithMoleculeAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,134 @@
+/*
+ * FillWithMoleculeAction.cpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#include "Actions/MoleculeAction/FillWithMoleculeAction.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+#include "atom.hpp"
+#include "bondgraph.hpp"
+#include "boundary.hpp"
+#include "config.hpp"
+#include "defs.hpp"
+#include "molecule.hpp"
+#include "periodentafel.hpp"
+#include "vector.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+/****** MoleculeFillWithMoleculeAction *****/
+
+// memento to remember the state when undoing
+
+//class MoleculeFillWithMoleculeState : public ActionState {
+//public:
+//  MoleculeFillWithMoleculeState(molecule* _mol,std::string _lastName) :
+//    mol(_mol),
+//    lastName(_lastName)
+//  {}
+//  molecule* mol;
+//  std::string lastName;
+//};
+
+const char MoleculeFillWithMoleculeAction::NAME[] = "fill-molecule";
+
+MoleculeFillWithMoleculeAction::MoleculeFillWithMoleculeAction() :
+  Action(NAME)
+{}
+
+MoleculeFillWithMoleculeAction::~MoleculeFillWithMoleculeAction()
+{}
+
+Action::state_ptr MoleculeFillWithMoleculeAction::performCall() {
+  string filename;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  Vector distances;
+  Vector lengths;
+  double MaxDistance = -1.;
+  bool DoRotate = false;
+
+  dialog->queryString(NAME, &filename, MapOfActions::getInstance().getDescription(NAME));
+  dialog->queryVector("distances", &distances, World::getInstance().getDomain(), false, MapOfActions::getInstance().getDescription("distances"));
+  dialog->queryVector("lengths", &lengths, World::getInstance().getDomain(), false, MapOfActions::getInstance().getDescription("lengths"));
+  dialog->queryBoolean("DoRotate", &DoRotate, MapOfActions::getInstance().getDescription("DoRotate"));
+  dialog->queryDouble("MaxDistance", &MaxDistance, MapOfActions::getInstance().getDescription("MaxDistance"));
+
+  if(dialog->display()) {
+    // construct water molecule
+    molecule *filler = World::getInstance().createMolecule();
+//    if (!filler->AddXYZFile(filename)) {
+//      DoeLog(0) && (eLog()<< Verbose(0) << "Could not parse filler molecule from " << filename << "." << endl);
+//    }
+//    filler->SetNameFromFilename(filename);
+    molecule *Filling = NULL;
+    atom *first = NULL, *second = NULL, *third = NULL;
+    first = World::getInstance().createAtom();
+    first->type = World::getInstance().getPeriode()->FindElement(1);
+    first->x = Vector(0.441, -0.143, 0.);
+    filler->AddAtom(first);
+    second = World::getInstance().createAtom();
+    second->type = World::getInstance().getPeriode()->FindElement(1);
+    second->x = Vector(-0.464, 1.137, 0.0);
+    filler->AddAtom(second);
+    third = World::getInstance().createAtom();
+    third->type = World::getInstance().getPeriode()->FindElement(8);
+    third->x = Vector(-0.464, 0.177, 0.);
+    filler->AddAtom(third);
+    filler->AddBond(first, third, 1);
+    filler->AddBond(second, third, 1);
+    World::getInstance().getConfig()->BG->ConstructBondGraph(filler);
+    filler->SetNameFromFilename("water");
+    // call routine
+    double distance[NDIM];
+    for (int i=0;i<NDIM;i++)
+      distance[i] = distances[i];
+    Filling = FillBoxWithMolecule(World::getInstance().getMolecules(), filler, *(World::getInstance().getConfig()), MaxDistance, distance, lengths[0], lengths[1], lengths[2], DoRotate);
+    if (Filling != NULL) {
+      Filling->ActiveFlag = false;
+      World::getInstance().getMolecules()->insert(Filling);
+    }
+    World::getInstance().destroyMolecule(filler);
+
+    delete dialog;
+    return Action::success;
+  }
+  delete dialog;
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeFillWithMoleculeAction::performUndo(Action::state_ptr _state) {
+//  MoleculeFillWithMoleculeState *state = assert_cast<MoleculeFillWithMoleculeState*>(_state.get());
+
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeFillWithMoleculeAction::performRedo(Action::state_ptr _state){
+  // Undo and redo have to do the same for this action
+  return performUndo(_state);
+}
+
+bool MoleculeFillWithMoleculeAction::canUndo() {
+  return false;
+}
+
+bool MoleculeFillWithMoleculeAction::shouldUndo() {
+  return false;
+}
+
+const string MoleculeFillWithMoleculeAction::getName() {
+  return NAME;
+}
Index: src/Actions/MoleculeAction/FillWithMoleculeAction.hpp
===================================================================
--- src/Actions/MoleculeAction/FillWithMoleculeAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/FillWithMoleculeAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,34 @@
+/*
+ * FillWithMoleculeAction.hpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#ifndef FILLWITHMOLECULEACTION_HPP
+#define FILLWITHMOLECULEACTION_HPP
+
+#include "Actions/Action.hpp"
+#include "Actions/Process.hpp"
+
+class MoleculeListClass;
+
+class MoleculeFillWithMoleculeAction : public Action {
+public:
+  MoleculeFillWithMoleculeAction();
+  virtual ~MoleculeFillWithMoleculeAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+
+#endif // FILLWITHMOLECULEACTION_HPP
Index: src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp
===================================================================
--- src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,107 @@
+/*
+ * LinearInterpolationofTrajectoriesAction.cpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#include "Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp"
+
+#include <iostream>
+#include <fstream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+#include "atom.hpp"
+#include "defs.hpp"
+#include "log.hpp"
+#include "molecule.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+/****** MoleculeLinearInterpolationofTrajectoriesAction *****/
+
+// memento to remember the state when undoing
+
+//class MoleculeLinearInterpolationofTrajectoriesState : public ActionState {
+//public:
+//  MoleculeLinearInterpolationofTrajectoriesState(molecule* _mol,std::string _lastName) :
+//    mol(_mol),
+//    lastName(_lastName)
+//  {}
+//  molecule* mol;
+//  std::string lastName;
+//};
+
+const char MoleculeLinearInterpolationofTrajectoriesAction::NAME[] = "linear-interpolate";
+
+MoleculeLinearInterpolationofTrajectoriesAction::MoleculeLinearInterpolationofTrajectoriesAction() :
+  Action(NAME)
+{}
+
+MoleculeLinearInterpolationofTrajectoriesAction::~MoleculeLinearInterpolationofTrajectoriesAction()
+{}
+
+Action::state_ptr MoleculeLinearInterpolationofTrajectoriesAction::performCall() {
+  string filename;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  molecule *mol = NULL;
+  int start = -1;
+  int end = -1;
+  bool IdMapping = true;
+
+
+  dialog->queryString(NAME, &filename, MapOfActions::getInstance().getDescription(NAME));
+  dialog->queryInt("start-mol", &start, MapOfActions::getInstance().getDescription("start"));
+  dialog->queryInt("end-mol", &start, MapOfActions::getInstance().getDescription("end"));
+  dialog->queryMolecule("molecule-by-id", &mol, MapOfActions::getInstance().getDescription("molecule-by-id"));
+  dialog->queryBoolean("id-mapping", &IdMapping, MapOfActions::getInstance().getDescription("id-mapping"));
+
+  if(dialog->display()) {
+    DoLog(1) && (Log() << Verbose(1) << "Linear interpolation between configuration " << start << " and " << end << "." << endl);
+    if (IdMapping)
+      DoLog(1) && (Log() << Verbose(1) << "Using Identity for the permutation map." << endl);
+    char outputname[MAXSTRINGSIZE];
+    strcpy(outputname, filename.c_str());
+    // TODO: LinearInterpolationBetweenConfiguration should use stream, not the filename directly! (better for unit test)
+    if (!mol->LinearInterpolationBetweenConfiguration(start, end, outputname, *(World::getInstance().getConfig()), IdMapping))
+      DoLog(2) && (Log() << Verbose(2) << "Could not store " << outputname << " files." << endl);
+    else
+      DoLog(2) && (Log() << Verbose(2) << "Steps created and " << filename << " files stored." << endl);
+    delete dialog;
+    return Action::success;
+  }
+  delete dialog;
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeLinearInterpolationofTrajectoriesAction::performUndo(Action::state_ptr _state) {
+//  MoleculeLinearInterpolationofTrajectoriesState *state = assert_cast<MoleculeLinearInterpolationofTrajectoriesState*>(_state.get());
+
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeLinearInterpolationofTrajectoriesAction::performRedo(Action::state_ptr _state){
+  // Undo and redo have to do the same for this action
+  return performUndo(_state);
+}
+
+bool MoleculeLinearInterpolationofTrajectoriesAction::canUndo() {
+  return false;
+}
+
+bool MoleculeLinearInterpolationofTrajectoriesAction::shouldUndo() {
+  return false;
+}
+
+const string MoleculeLinearInterpolationofTrajectoriesAction::getName() {
+  return NAME;
+}
Index: src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp
===================================================================
--- src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,34 @@
+/*
+ * LinearInterpolationofTrajectoriesAction.hpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#ifndef LINEARINTERPOLATIONOFTRAJECTORIES_HPP
+#define LINEARINTERPOLATIONOFTRAJECTORIES_HPP
+
+#include "Actions/Action.hpp"
+#include "Actions/Process.hpp"
+
+class MoleculeListClass;
+
+class MoleculeLinearInterpolationofTrajectoriesAction : public Action {
+public:
+  MoleculeLinearInterpolationofTrajectoriesAction();
+  virtual ~MoleculeLinearInterpolationofTrajectoriesAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+
+#endif // LINEARINTERPOLATIONOFTRAJECTORIES_HPP
Index: src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.cpp
===================================================================
--- src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,87 @@
+/*
+ * RotateToPrincipalAxisSystemAction.cpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#include "Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.hpp"
+
+#include <iostream>
+#include <fstream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+#include "log.hpp"
+#include "molecule.hpp"
+#include "verbose.hpp"
+
+/****** MoleculeRotateToPrincipalAxisSystemAction *****/
+
+// memento to remember the state when undoing
+
+//class MoleculeRotateToPrincipalAxisSystemState : public ActionState {
+//public:
+//  MoleculeRotateToPrincipalAxisSystemState(molecule* _mol,std::string _lastName) :
+//    mol(_mol),
+//    lastName(_lastName)
+//  {}
+//  molecule* mol;
+//  std::string lastName;
+//};
+
+const char MoleculeRotateToPrincipalAxisSystemAction::NAME[] = "rotate-to-pas";
+
+MoleculeRotateToPrincipalAxisSystemAction::MoleculeRotateToPrincipalAxisSystemAction() :
+  Action(NAME)
+{}
+
+MoleculeRotateToPrincipalAxisSystemAction::~MoleculeRotateToPrincipalAxisSystemAction()
+{}
+
+Action::state_ptr MoleculeRotateToPrincipalAxisSystemAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  molecule *mol = NULL;
+
+  dialog->queryMolecule(NAME, &mol, MapOfActions::getInstance().getDescription(NAME));
+
+  if(dialog->display()) {
+    DoLog(0) && (Log() << Verbose(0) << "Converting to prinicipal axis system." << endl);
+    mol->PrincipalAxisSystem(true);
+    delete dialog;
+    return Action::success;
+  }
+  delete dialog;
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeRotateToPrincipalAxisSystemAction::performUndo(Action::state_ptr _state) {
+//  MoleculeRotateToPrincipalAxisSystemState *state = assert_cast<MoleculeRotateToPrincipalAxisSystemState*>(_state.get());
+
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeRotateToPrincipalAxisSystemAction::performRedo(Action::state_ptr _state){
+  // Undo and redo have to do the same for this action
+  return performUndo(_state);
+}
+
+bool MoleculeRotateToPrincipalAxisSystemAction::canUndo() {
+  return false;
+}
+
+bool MoleculeRotateToPrincipalAxisSystemAction::shouldUndo() {
+  return false;
+}
+
+const string MoleculeRotateToPrincipalAxisSystemAction::getName() {
+  return NAME;
+}
Index: src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.hpp
===================================================================
--- src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,34 @@
+/*
+ * RotateToPrincipalAxisSystemAction.hpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#ifndef ROTATETOPRINCIPALAXISSYSTEMACTION_HPP
+#define ROTATETOPRINCIPALAXISSYSTEMACTION_HPP
+
+#include "Actions/Action.hpp"
+#include "Actions/Process.hpp"
+
+class MoleculeListClass;
+
+class MoleculeRotateToPrincipalAxisSystemAction : public Action {
+public:
+  MoleculeRotateToPrincipalAxisSystemAction();
+  virtual ~MoleculeRotateToPrincipalAxisSystemAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+
+#endif // ROTATETOPRINCIPALAXISSYSTEMACTION_HPP
Index: src/Actions/MoleculeAction/SaveAdjacencyAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SaveAdjacencyAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/SaveAdjacencyAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,99 @@
+/*
+ * SaveAdjacencyAction.cpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#include "Actions/MoleculeAction/SaveAdjacencyAction.hpp"
+
+#include <iostream>
+#include <fstream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+#include "atom.hpp"
+#include "bondgraph.hpp"
+#include "config.hpp"
+#include "defs.hpp"
+#include "log.hpp"
+#include "molecule.hpp"
+#include "vector.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+/****** MoleculeSaveAdjacencyAction *****/
+
+// memento to remember the state when undoing
+
+//class MoleculeSaveAdjacencyState : public ActionState {
+//public:
+//  MoleculeSaveAdjacencyState(molecule* _mol,std::string _lastName) :
+//    mol(_mol),
+//    lastName(_lastName)
+//  {}
+//  molecule* mol;
+//  std::string lastName;
+//};
+
+const char MoleculeSaveAdjacencyAction::NAME[] = "save-adjacency";
+
+MoleculeSaveAdjacencyAction::MoleculeSaveAdjacencyAction() :
+  Action(NAME)
+{}
+
+MoleculeSaveAdjacencyAction::~MoleculeSaveAdjacencyAction()
+{}
+
+Action::state_ptr MoleculeSaveAdjacencyAction::performCall() {
+  string filename;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  molecule *mol = NULL;
+
+  dialog->queryString(NAME, &filename, MapOfActions::getInstance().getDescription(NAME));
+  dialog->queryMolecule("molecule-by-id", &mol, MapOfActions::getInstance().getDescription("molecule-by-id"));
+
+  if(dialog->display()) {
+    DoLog(0) && (Log() << Verbose(0) << "Storing adjacency to path " << filename << "." << endl);
+    World::getInstance().getConfig()->BG->ConstructBondGraph(mol);
+    // TODO: sollte stream nicht filename benutzen, besser fuer unit test
+    char outputname[MAXSTRINGSIZE];
+    strcpy(outputname, filename.c_str());
+    mol->StoreAdjacencyToFile(NULL, outputname);
+    delete dialog;
+    return Action::success;
+  }
+  delete dialog;
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeSaveAdjacencyAction::performUndo(Action::state_ptr _state) {
+//  MoleculeSaveAdjacencyState *state = assert_cast<MoleculeSaveAdjacencyState*>(_state.get());
+
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeSaveAdjacencyAction::performRedo(Action::state_ptr _state){
+  // Undo and redo have to do the same for this action
+  return performUndo(_state);
+}
+
+bool MoleculeSaveAdjacencyAction::canUndo() {
+  return false;
+}
+
+bool MoleculeSaveAdjacencyAction::shouldUndo() {
+  return false;
+}
+
+const string MoleculeSaveAdjacencyAction::getName() {
+  return NAME;
+}
Index: src/Actions/MoleculeAction/SaveAdjacencyAction.hpp
===================================================================
--- src/Actions/MoleculeAction/SaveAdjacencyAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/SaveAdjacencyAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,34 @@
+/*
+ * SaveAdjacencyAction.hpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#ifndef SAVEADJACENCYACTION_HPP
+#define SAVEADJACENCYACTION_HPP
+
+#include "Actions/Action.hpp"
+#include "Actions/Process.hpp"
+
+class MoleculeListClass;
+
+class MoleculeSaveAdjacencyAction : public Action {
+public:
+  MoleculeSaveAdjacencyAction();
+  virtual ~MoleculeSaveAdjacencyAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+
+#endif // SAVEADJACENCYACTION_HPP
Index: src/Actions/MoleculeAction/SaveBondsAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SaveBondsAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/SaveBondsAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,99 @@
+/*
+ * SaveBondsAction.cpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#include "Actions/MoleculeAction/SaveBondsAction.hpp"
+
+#include <iostream>
+#include <fstream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+#include "atom.hpp"
+#include "bondgraph.hpp"
+#include "config.hpp"
+#include "defs.hpp"
+#include "log.hpp"
+#include "molecule.hpp"
+#include "vector.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+/****** MoleculeSaveBondsAction *****/
+
+// memento to remember the state when undoing
+
+//class MoleculeSaveBondsState : public ActionState {
+//public:
+//  MoleculeSaveBondsState(molecule* _mol,std::string _lastName) :
+//    mol(_mol),
+//    lastName(_lastName)
+//  {}
+//  molecule* mol;
+//  std::string lastName;
+//};
+
+const char MoleculeSaveBondsAction::NAME[] = "save-bonds";
+
+MoleculeSaveBondsAction::MoleculeSaveBondsAction() :
+  Action(NAME)
+{}
+
+MoleculeSaveBondsAction::~MoleculeSaveBondsAction()
+{}
+
+Action::state_ptr MoleculeSaveBondsAction::performCall() {
+  string filename;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  molecule *mol = NULL;
+
+  dialog->queryString(NAME, &filename, MapOfActions::getInstance().getDescription(NAME));
+  dialog->queryMolecule("molecule-by-id", &mol, MapOfActions::getInstance().getDescription("molecule-by-id"));
+
+  if(dialog->display()) {
+    DoLog(0) && (Log() << Verbose(0) << "Storing bonds to path " << filename << "." << endl);
+    World::getInstance().getConfig()->BG->ConstructBondGraph(mol);
+    // TODO: sollte stream, nicht filenamen direkt nutzen, beser fuer unit tests
+    char outputname[MAXSTRINGSIZE];
+    strcpy(outputname, filename.c_str());
+    mol->StoreBondsToFile(NULL, outputname);
+    delete dialog;
+    return Action::success;
+  }
+  delete dialog;
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeSaveBondsAction::performUndo(Action::state_ptr _state) {
+//  MoleculeSaveBondsState *state = assert_cast<MoleculeSaveBondsState*>(_state.get());
+
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeSaveBondsAction::performRedo(Action::state_ptr _state){
+  // Undo and redo have to do the same for this action
+  return performUndo(_state);
+}
+
+bool MoleculeSaveBondsAction::canUndo() {
+  return false;
+}
+
+bool MoleculeSaveBondsAction::shouldUndo() {
+  return false;
+}
+
+const string MoleculeSaveBondsAction::getName() {
+  return NAME;
+}
Index: src/Actions/MoleculeAction/SaveBondsAction.hpp
===================================================================
--- src/Actions/MoleculeAction/SaveBondsAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/SaveBondsAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,34 @@
+/*
+ * SaveBondsAction.hpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#ifndef SAVEBONDSACTION_HPP
+#define SAVEBONDSACTION_HPP
+
+#include "Actions/Action.hpp"
+#include "Actions/Process.hpp"
+
+class MoleculeListClass;
+
+class MoleculeSaveBondsAction : public Action {
+public:
+  MoleculeSaveBondsAction();
+  virtual ~MoleculeSaveBondsAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+
+#endif // SAVEBONDSACTION_HPP
Index: src/Actions/MoleculeAction/SaveTemperatureAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SaveTemperatureAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/SaveTemperatureAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,97 @@
+/*
+ * SaveTemperatureAction.cpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#include "Actions/MoleculeAction/SaveTemperatureAction.hpp"
+
+#include <iostream>
+#include <fstream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+#include "atom.hpp"
+#include "log.hpp"
+#include "molecule.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+/****** MoleculeSaveTemperatureAction *****/
+
+// memento to remember the state when undoing
+
+//class MoleculeSaveTemperatureState : public ActionState {
+//public:
+//  MoleculeSaveTemperatureState(molecule* _mol,std::string _lastName) :
+//    mol(_mol),
+//    lastName(_lastName)
+//  {}
+//  molecule* mol;
+//  std::string lastName;
+//};
+
+const char MoleculeSaveTemperatureAction::NAME[] = "save-temperature";
+
+MoleculeSaveTemperatureAction::MoleculeSaveTemperatureAction() :
+  Action(NAME)
+{}
+
+MoleculeSaveTemperatureAction::~MoleculeSaveTemperatureAction()
+{}
+
+Action::state_ptr MoleculeSaveTemperatureAction::performCall() {
+  string filename;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  molecule *mol = NULL;
+
+  dialog->queryString(NAME, &filename, MapOfActions::getInstance().getDescription(NAME));
+  dialog->queryMolecule("molecule-by-id", &mol, MapOfActions::getInstance().getDescription("molecule-by-id"));
+
+  if(dialog->display()) {
+    DoLog(1) && (Log() << Verbose(1) << "Storing temperatures in " << filename << "." << endl);
+    ofstream output;
+    output.open(filename.c_str(), ios::trunc);
+    if (output.fail() || !mol->OutputTemperatureFromTrajectories((ofstream * const) &output, 0, mol->MDSteps))
+      DoLog(2) && (Log() << Verbose(2) << "File could not be written." << endl);
+    else
+      DoLog(2) && (Log() << Verbose(2) << "File stored." << endl);
+    output.close();
+    delete dialog;
+    return Action::success;
+  }
+  delete dialog;
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeSaveTemperatureAction::performUndo(Action::state_ptr _state) {
+//  MoleculeSaveTemperatureState *state = assert_cast<MoleculeSaveTemperatureState*>(_state.get());
+
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeSaveTemperatureAction::performRedo(Action::state_ptr _state){
+  // Undo and redo have to do the same for this action
+  return performUndo(_state);
+}
+
+bool MoleculeSaveTemperatureAction::canUndo() {
+  return false;
+}
+
+bool MoleculeSaveTemperatureAction::shouldUndo() {
+  return false;
+}
+
+const string MoleculeSaveTemperatureAction::getName() {
+  return NAME;
+}
Index: src/Actions/MoleculeAction/SaveTemperatureAction.hpp
===================================================================
--- src/Actions/MoleculeAction/SaveTemperatureAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/SaveTemperatureAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,34 @@
+/*
+ * SaveTemperatureAction.hpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#ifndef SAVETEMPERATUREACTION_HPP
+#define SAVETEMPERATUREACTION_HPP
+
+#include "Actions/Action.hpp"
+#include "Actions/Process.hpp"
+
+class MoleculeListClass;
+
+class MoleculeSaveTemperatureAction : public Action {
+public:
+  MoleculeSaveTemperatureAction();
+  virtual ~MoleculeSaveTemperatureAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+
+#endif // SAVETEMPERATUREACTION_HPP
